#include "stdafx.h"
#include "avifile.h"
#include "dialog.h"



HANDLE __stdcall MyOpenArchive (tOpenArchiveData *ArchiveData);
int __stdcall MyReadHeader (HANDLE hArcData, tHeaderData *HeaderData);
int __stdcall MyProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName);
int __stdcall MyCloseArchive (HANDLE hArcData);
void __stdcall SetChangeVolProc (HANDLE hArcData, tChangeVolProc pChangeVolProc1);
void __stdcall SetProcessDataProc (HANDLE hArcData, tProcessDataProc pProcessDataProc);
int __stdcall GetPackerCaps();
void __stdcall ConfigurePacker (HWND Parent, HINSTANCE DllInstance);
int __stdcall PackFiles (char *PackedFile, char *SubPath, char *SrcPath, char *AddList, int Flags);
int __stdcall DeleteFiles (char *PackedFile, char *DeleteList);




tProcessDataProc gProcessDataProc; 



BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}



HANDLE _stdcall MyOpenArchive(tOpenArchiveData *ArchiveData)
{
	// Opens an avi file for reading
	PAviFile file=new CAviFile;

	if (!file->Load(ArchiveData->ArcName))
	{
		delete file;
		ArchiveData->OpenResult=E_BAD_ARCHIVE;
		return 0;
	}
	return file;
}

int __stdcall MyCloseArchive(HANDLE hArcData)
{
	// Closes an avi file
	delete ((PAviFile)(hArcData));
	return 0;
}


int __stdcall MyReadHeader(HANDLE hArcData,tHeaderData *HeaderData)
{
	// Reads avi header
	return ((PAviFile)(hArcData))->ReadHeader(HeaderData);
}

int __stdcall MyProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName)
{
	// Extract frame data from avi file
	return ((PAviFile)(hArcData))->ProcessFile(Operation,DestPath,DestName);
}

void __stdcall SetChangeVolProc (HANDLE hArcData, tChangeVolProc pChangeVolProc1)
{
}

void __stdcall MySetProcessDataProc (HANDLE hArcData, tProcessDataProc pProcessDataProc)
{
	// Set local or global callback proc for ProcessData
	if (hArcData==INVALID_HANDLE_VALUE)
	{
		gProcessDataProc=pProcessDataProc;
		return;
	}
	((PAviFile)(hArcData))->SetProcessDataProc(pProcessDataProc);
}

int __stdcall GetPackerCaps()
{
	// Only accept new, options and multiple files and hide the package (no modifying and deleting)
	return PK_CAPS_MULTIPLE|PK_CAPS_OPTIONS|PK_CAPS_NEW|PK_CAPS_HIDE/*|PK_CAPS_MODIFY|PK_CAPS_DELETE*/;
}

void __stdcall ConfigurePacker (HWND Parent, HINSTANCE DllInstance)
{
	// Configure packer options (framerate)
	RunConfigDialog(Parent,DllInstance);
}

int __stdcall PackFiles (char *PackedFile, char *SubPath, char *SrcPath, char *AddList, int Flags)
{
	// Encode a set of files to an avi file
	PCHAR file=AddList;
	CAviWrite* write=new CAviWrite;

	CHAR c[MAX_PATH];
	sprintf(&c[0],"%s%s",SrcPath,file);
	if (write->Create(PackedFile)==FALSE)
	{
		delete write;
		return E_ECREATE;
	}
	DWORD filesize=0;

	while ((*file)!='\0')
	{
		sprintf(&c[0],"%s%s",SrcPath,file);
		if (gProcessDataProc(file,filesize)==0)
		{
			delete write;
			return E_EABORTED;
		}
		{	// Receive File-Size
			HANDLE h=CreateFile(&c[0],GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,0);
			if (h==INVALID_HANDLE_VALUE)filesize=0;
				else filesize=GetFileSize(h,NULL);
			CloseHandle(h);
		}
//		Add current file

#ifdef _DEBUG
		OutputDebugString("Add file: ");
		OutputDebugString(&c[0]);
		OutputDebugString("\n");
#endif
		if (write->Add(&c[0])==FALSE)
		{
			delete write;
			return E_NOT_SUPPORTED;
		}

//		Search for next file 
		while (*(file++)!='\0');
	}
	// Well done
	delete write;
	return 0;
}

int __stdcall DeleteFiles (char *PackedFile, char *DeleteList)
{
	return E_NOT_SUPPORTED;
}


