#include "wcxhead.h"
#include "vfw.h"


inline int FileTime(int year,int month,int day,int hour,int minute,int second)
{
	return (((year - 1980) << 25) | (month << 21) | (day << 16) | (hour << 11) | (minute << 5) | (second/2));
}


class CAviFile
{
private:
	PCHAR ArcName;

	PAVIFILE avi;
	PAVISTREAM stream;
	PAVISTREAM audio;
	PGETFRAME frame;
	AVISTREAMINFO info,audioinfo;
	HDRAWDIB hdd;

	DWORD index;

	DWORD filesize;
	long audiosize;
	WIN32_FILE_ATTRIBUTE_DATA attr;
	int filetime;

	tProcessDataProc ProcessDataProc;

	inline LPBITMAPINFOHEADER GetDIBitmapFrame(int nr);
	int ExtractAudio(PCHAR filename);
public:
	CAviFile();
	~CAviFile();

	BOOLEAN Load(PCHAR file);

	int ReadHeader(tHeaderData *HeaderData);
	int ProcessFile (int Operation, char *DestPath, char *DestName);
	void SetProcessDataProc(tProcessDataProc pProcessDataProc);
};

typedef CAviFile* PAviFile;


class CAviWrite
{
private:
	AVISTREAMINFO strhdr;
	PAVIFILE pfile;
	PAVISTREAM ps, psCompressed;
	AVICOMPRESSOPTIONS opts;
	AVICOMPRESSOPTIONS FAR * aopts[1];

	int index;
	int width,height;

	BOOLEAN InitVideoStream(PCHAR file);
public:
	CAviWrite();
	~CAviWrite();

	BOOLEAN Create(PCHAR file);
	BOOLEAN Add(PCHAR file);
	BOOLEAN AddAudio(PCHAR file);
};


BOOLEAN SaveBitmap(HBITMAP bitmap,HDC dc,PCHAR filename);
extern tProcessDataProc ProcessDataProc;



// -- inline functions


inline LPBITMAPINFOHEADER CAviFile::GetDIBitmapFrame(int nr)
{	
	// Returns a bitmap of the indexed frame
	return (LPBITMAPINFOHEADER)AVIStreamGetFrame(frame,index);
}


// -- end



