/*****************************************************************************
**
**  FILE   :	GlobalVars.h
**
**  PURPOSE:	
**
**	Author:		Konstantin Polyakov
**
*****************************************************************************/

#ifndef __GLOBALVARS_H__
#define __GLOBALVARS_H__

#include "windows.h"
#include "wcxhead.h"

#define	SUCCESS				0
#define	OPTION_PAGES		4
#define INDENT_SIZE			3
#define MASK_LIST_LENGTH	50
#define FILE_NAME_LENGTH	256
#define STRING_LENGTH		1000
#define PATH_LENGTH			1000
#define EXT_LENGTH			10

#define COL_NAME	0
#define COL_EXT		1
#define COL_SIZE	2
#define COL_DATE	3
#define COL_TIME	4
#define COL_ATTR	5

#define COLUMN_NUMBER	6

typedef struct _TDlgDesc { 
    HWND hTabCtrl;
    HWND hCurDlg;  
	HWND hChildDlg[OPTION_PAGES];
	DLGTEMPLATE *ChildDlgRes[OPTION_PAGES];
} TDlgDesc;

typedef struct _TViewParam{ 
	BOOL	bDirName;
	BOOL	bFileName;
	BOOL	bFullName;
	BOOL	bExt;
	BOOL	bSize;
	BOOL	bDate;
	BOOL	bTime;
	BOOL	bAttr;
	char	sFileTypes[MASK_LIST_LENGTH];
} TViewParam;

typedef struct _TSortParam{ 
	BOOL	bName;
	BOOL	bSize;
	BOOL	bDate;
	BOOL	bExt;
	BOOL	bDescent;
} TSortParam;

typedef struct _TFormatParam{ 
	BOOL	bIndentFiles;
	BOOL	bIndentAll;
	UINT	Width;
	BOOL	bExtSeparately;
} TFormatParam;

#define TYPE_DIRECTORY	0
#define TYPE_FILE		1

typedef struct _TFileList{
	char		*pOriginalName;
	char		*pName;
	char		*pExt;
	UCHAR		iType;
	DWORD		iSize;
	FILETIME	DateTime;
	DWORD		Attr;
} TFileList;


typedef struct _TRxDesc{
	char		pBuf[STRING_LENGTH];
	char		DirName[STRING_LENGTH];
	USHORT		iReadPos;
	USHORT		iWritePos;
	BOOL		bNeedData;
	UCHAR		iThisIsHeader;
} TRxDesc;

typedef struct _TFileInfo{
	char		Name[256];
	DWORD		iSize;
	DWORD		Attr;
	DWORD		Year;
	DWORD		Month;
	DWORD		Day;
	DWORD		Hour;
	DWORD		Minute;
	DWORD		Second;
} TFileInfo;

typedef void( TColumnHandler )( 
		char *pStr,
		USHORT StrLen,
		TFileInfo *pFileInfo
		);


typedef struct _TListInfo{
	TColumnHandler	*HandleFunc;
	USHORT			StartIdx;
	USHORT			Len;
} TListInfo;

// 
extern TViewParam		g_ViewParam;
extern TSortParam		g_SortParam;
extern TFormatParam		g_FormatParam;


extern TDlgDesc		g_DlgDesc;		// 
extern TRxDesc		g_RxDesc;
extern TListInfo	g_ListInfo[COLUMN_NUMBER];

extern HINSTANCE		g_hinst;		// handle to dll instance
extern HMODULE			g_hModuleDll;	// handle to dll module
extern tProcessDataProc g_ProcessDataProc;
extern HWND				g_MainWin;
extern char				g_pWorkingDir[100];
extern char				g_pCfgFileName[30];


#endif

