// VCComp.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Options(HWND, UINT, WPARAM, LPARAM);


HWND g_hWnd;
CRunFilters *g_rf;// Run filters - main class

//UIs UI;
extern Codec Codecs[];

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_VCCOMP, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}
	
	HRESULT hr = CoInitialize(NULL);
	CheckErrMsg(hr,L"COM initialization error");
	g_rf = new(CRunFilters);
	hr = g_rf->InitCommonFilters();		
	CheckErrMsg(hr,L"Some Necessary components not found - exiting program");

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_VCCOMP);
		
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	delete g_rf;
	CoUninitialize();
	UnregisterClass(szWindowClass, hInstance);
	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_VCCOMP);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1); //(COLOR_MENU+1)
	wcex.lpszMenuName	= (LPCWCH)IDC_VCCOMP;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_LGICON);//IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   

   hInst = hInstance; // Store instance handle in our global variable

   g_hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!g_hWnd)
   {
      return FALSE;
   }

   ShowWindow(g_hWnd, nCmdShow);
   UpdateWindow(g_hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
	HRESULT hr = S_OK;
	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ZOOMIN:
					g_rf->Zoom(1);
					hr = g_rf->ShowVideoWindows();
					break;
				case IDM_ZOOMOUT:
					g_rf->Zoom(-1);
					hr = g_rf->ShowVideoWindows();
					break;
				case IDM_FULLSCREEN:
					ShowWindow(g_hWnd,SW_MAXIMIZE);
					g_rf->Zoom(3);
					hr = g_rf->ShowVideoWindows();
					break;
				case IDM_OPTIONS:
					DialogBox(hInst, (LPCTSTR)IDD_OPTIONS, hWnd, (DLGPROC)Options);
					break;
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


// Mesage handler for option box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
		
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}


// Mesage handler for about box.
LRESULT CALLBACK Options(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hLeft,hRight,hTmFrame,hErrSim;
	HRESULT hr;
	int rv,i;
	
	hLeft    =  GetDlgItem(hDlg,IDC_COMBOLEFTCODEC);
	hRight   =  GetDlgItem(hDlg,IDC_COMBORIGHTCODEC);
	hTmFrame =  GetDlgItem(hDlg,IDC_PERIOD);
	hErrSim  =  GetDlgItem(hDlg,IDC_ERRSIM);
	int codecSel1, codecSel2;
	TCHAR  bufStr[100];
	int bufInt = 1;
	switch (message)
	{
		case WM_INITDIALOG:
				g_rf->Stop();
				for ( i = 0; i< NUM_OF_CODECS; i++)
				{
				    rv = SendMessage(  hLeft, CB_ADDSTRING, (WPARAM) 0, (LPARAM)Codecs[i].name);
					rv = SendMessage(  hRight, CB_ADDSTRING, (WPARAM) 0, (LPARAM)Codecs[i].name);
				}
				rv = SendMessage(  hLeft, CB_SETCURSEL,  (WPARAM)g_rf->m_iCodec[0], (LPARAM)0);
				rv = SendMessage(  hRight, CB_SETCURSEL,  (WPARAM)g_rf->m_iCodec[1], (LPARAM)0);
				bufInt = g_rf->MonitorsGetTimeWindow();
				swprintf(bufStr,L"%d",bufInt);
				SendMessage(  hTmFrame, WM_SETTEXT,(WPARAM) 0, (LPARAM) bufStr);
				if (g_rf->MonitorsGetUseErrSim() )
					rv = SendMessage(  hErrSim, BM_SETCHECK,(WPARAM) BST_CHECKED, (LPARAM) 0);
				else 
					rv = SendMessage(  hErrSim, BM_SETCHECK,(WPARAM) BST_UNCHECKED, (LPARAM) 0);
				return TRUE;
		case WM_COMMAND:
			switch  ( LOWORD(wParam) )
			{
			case IDC_CREATETEST:
				SendMessage(  hTmFrame, WM_GETTEXT,(WPARAM) 5, (LPARAM) bufStr);
				bufInt = _wtoi(bufStr);
				codecSel1 = SendMessage(  hLeft, CB_GETCURSEL,(WPARAM) 0, (LPARAM) 0);
				codecSel2 = SendMessage(  hRight,CB_GETCURSEL,(WPARAM) 0, (LPARAM) 0);
				hr = g_rf->CreateTest(codecSel1,codecSel2,bufInt);
				break;
			case IDC_BUTTONLP:
				rv = SendMessage(  hLeft, CB_GETCURSEL,(WPARAM) 0, (LPARAM) 0);
				g_rf->UIShowPropPage( 0, rv);
				break;
			case IDC_BUTTONRP:
				rv = SendMessage(  hRight, CB_GETCURSEL,(WPARAM) 0, (LPARAM) 0);
				g_rf->UIShowPropPage( 1, rv);
				break;
			case IDC_ERRSIM:
				rv = SendMessage	(hErrSim,BM_GETCHECK ,WPARAM(0),LPARAM(0) );
				if ( rv == BST_CHECKED )
				{
					if ( !g_rf->SetErrFile() )
						rv = SendMessage(  hErrSim, BM_SETCHECK,(WPARAM) BST_UNCHECKED, (LPARAM) 0);
				} 
				else g_rf->MonitorsSetErrSim(FALSE);
				break;
			case IDOK :
				SendMessage(  hTmFrame, WM_GETTEXT,(WPARAM) 5, (LPARAM) bufStr);
				bufInt = _wtoi(bufStr);
				if ( FAILED(g_rf->MonitorsSetTimeWindow(bufInt)) )
					return false;
				g_rf->MonitorsReset();
				codecSel1 = SendMessage(  hLeft, CB_GETCURSEL,(WPARAM) 0, (LPARAM) 0);
				codecSel2 = SendMessage(  hRight,CB_GETCURSEL,(WPARAM) 0, (LPARAM) 0);
				if (codecSel1 != g_rf->m_iCodec[0] || codecSel2 != g_rf->m_iCodec[1] )
				{
					rv = MessageBox(NULL,L"You've selected different codec but did not create a test. Would you like to Create a test 'press OK' or 'Press CANCEL' to cancel selection",
									  L"Attention",MB_OKCANCEL);
					if ( rv == IDOK )
						g_rf->CreateTest(codecSel1,codecSel2,bufInt);
				}
				EndDialog(hDlg, LOWORD(wParam));
				g_rf->Run();
				return TRUE;
			case IDCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				g_rf->Run();
				return TRUE;
			};
	}
    return FALSE;
}
