// fsplugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "fsplugin.h"

#define pluginrootlen 1

char* strlcpy(char* p,char*p2,int maxlen)
{
	if ((int)strlen(p2)>=maxlen) {
		strncpy(p,p2,maxlen);
		p[maxlen]=0;
	} else
		strcpy(p,p2);
	return p;
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

int PluginNumber;
tProgressProc ProgressProc;
tLogProc LogProc;
tRequestProc RequestProc;

int __stdcall FsInit(int PluginNr,tProgressProc pProgressProc,tLogProc pLogProc,tRequestProc pRequestProc)
{
	ProgressProc=pProgressProc;
    LogProc=pLogProc;
    RequestProc=pRequestProc;
	PluginNumber=PluginNr;
	return 0;
}

typedef struct {
	char Path[MAX_PATH];
	char LastFoundName[MAX_PATH];
	HANDLE searchhandle;
} tLastFindStuct,*pLastFindStuct;

HANDLE __stdcall FsFindFirst(char* Path,WIN32_FIND_DATA *FindData)
{
	char buf[MAX_PATH];
	pLastFindStuct lf;
	
	memset(FindData,0,sizeof(WIN32_FIND_DATA));
	if (strcmp(Path,"\\")==0) {
		FindData->dwFileAttributes=FILE_ATTRIBUTE_DIRECTORY;
		FindData->ftLastWriteTime.dwHighDateTime=0xFFFFFFFF;
		FindData->ftLastWriteTime.dwLowDateTime=0xFFFFFFFE;
		lf=(pLastFindStuct)malloc(sizeof(tLastFindStuct));
		strcpy(lf->Path,Path);
		lf->searchhandle=INVALID_HANDLE_VALUE;
		char ch='A';
		strcpy(buf,"A:\\");
		while (GetDriveType(buf)==DRIVE_NO_ROOT_DIR && ch<'Z'+1) {
			ch++;
			buf[0]=ch;
		}
		buf[2]=0;
		if (ch<='Z') {
			strcpy(lf->LastFoundName,buf);
			strcpy(FindData->cFileName,buf);
			return (HANDLE)lf;
		} else {
			free(lf);
			return INVALID_HANDLE_VALUE;
		}
	} else {
		strcpy(buf,Path+pluginrootlen);
		strcat(buf,"\\*.*");
		HANDLE hdnl=FindFirstFile(buf,FindData);
		if (hdnl==INVALID_HANDLE_VALUE)
			return INVALID_HANDLE_VALUE;
		else {
			lf=(pLastFindStuct)malloc(sizeof(tLastFindStuct));
			strcpy(lf->Path,buf);
			lf->searchhandle=hdnl;
			return (HANDLE)lf;
		}
	}
	return INVALID_HANDLE_VALUE;
}

BOOL __stdcall FsFindNext(HANDLE Hdl,WIN32_FIND_DATA *FindData)
{
	char buf[MAX_PATH];
	pLastFindStuct lf;

	if ((int)Hdl==1)
		return false;

	lf=(pLastFindStuct)Hdl;
	if (lf->searchhandle==INVALID_HANDLE_VALUE) {   // drive list!
		char ch=lf->LastFoundName[0];
		strcpy(buf,"A:\\");
		buf[0]=ch+1;
		while (GetDriveType(buf)==DRIVE_NO_ROOT_DIR && ch<'Z'+1) {
			ch++;
			buf[0]=ch;
		}
		buf[2]=0;
		if (ch<='Z') {
			strcpy(lf->LastFoundName,buf);
			strcpy(FindData->cFileName,buf);
			return true;
		} else {
			return false;
		}

	} else {
		lf=(pLastFindStuct)Hdl;
		return FindNextFile(lf->searchhandle,FindData);
	}
	return false;
}

int __stdcall FsFindClose(HANDLE Hdl)
{
	if ((int)Hdl==1)
		return 0;
	pLastFindStuct lf;
	lf=(pLastFindStuct)Hdl;
	if (lf->searchhandle!=INVALID_HANDLE_VALUE) {
		FindClose(lf->searchhandle);
		lf->searchhandle=INVALID_HANDLE_VALUE;
	}
	free(lf);
	return 0;
}

BOOL __stdcall FsMkDir(char* Path)
{
	char buf[MAX_PATH];
	if (strlen(Path)<pluginrootlen+2)
		return false;
	strlcpy(buf,Path,pluginrootlen);
	return CreateDirectory(Path+pluginrootlen,NULL);
}

int __stdcall FsExecuteFile(HWND MainWin,char* RemoteName,char* Verb)
{
    SHELLEXECUTEINFO shex;
	if (strlen(RemoteName)<pluginrootlen+2)
		return FS_EXEC_ERROR;
	if (stricmp(Verb,"open")==0) {
		return FS_EXEC_YOURSELF;
	} else if (stricmp(Verb,"properties")==0) {
        memset(&shex,0,sizeof(shex));
		shex.fMask=SEE_MASK_INVOKEIDLIST;
        shex.cbSize=sizeof(shex);
		shex.nShow=SW_SHOW;
		shex.hwnd=MainWin;
		shex.lpVerb=Verb;
		shex.lpFile=RemoteName+pluginrootlen;
		if (!ShellExecuteEx(&shex))
			return FS_EXEC_ERROR;
		else
			return FS_EXEC_OK;

	} else
		return FS_EXEC_ERROR;
}

int __stdcall FsRenMovFile(char* OldName,char* NewName,BOOL Move,BOOL OverWrite,RemoteInfoStruct* ri)
{
	if (strlen(OldName)<pluginrootlen+2 || strlen(NewName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;

	int err=ProgressProc(PluginNumber,OldName,NewName,0);
	if (err)
		return FS_FILE_USERABORT;

	if (Move) {
		if (OverWrite)
			DeleteFile(NewName+pluginrootlen);
		if (MoveFile(OldName+pluginrootlen,NewName+pluginrootlen))
			return FS_FILE_OK;
	} else {
		if (CopyFile(OldName+pluginrootlen,NewName+pluginrootlen,!OverWrite))
			return FS_FILE_OK;
	}
	switch(GetLastError()) {
		case ERROR_FILE_NOT_FOUND:
		case ERROR_PATH_NOT_FOUND:
		case ERROR_ACCESS_DENIED:
			return FS_FILE_NOTFOUND;
		case ERROR_FILE_EXISTS:
			return FS_FILE_EXISTS;
		default:
			return FS_FILE_WRITEERROR;
	}
	err=ProgressProc(PluginNumber,OldName,NewName,100);
	if (err)
		return FS_FILE_USERABORT;
}

int __stdcall FsGetFile(char* RemoteName,char* LocalName,int CopyFlags,RemoteInfoStruct* ri)
{
    int err;
	BOOL ok,OverWrite,Resume,Move;

	OverWrite=CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=CopyFlags & FS_COPYFLAGS_RESUME;
	Move=CopyFlags & FS_COPYFLAGS_MOVE;

	if (Resume)
		return FS_FILE_NOTSUPPORTED;

	if (strlen(RemoteName)<pluginrootlen+2 || strlen(RemoteName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;
	
	err=ProgressProc(PluginNumber,RemoteName,LocalName,0);
	if (err)
		return FS_FILE_USERABORT;
	if (Move) {
		if (OverWrite)
			DeleteFile(LocalName);
		ok=MoveFile(RemoteName+pluginrootlen,LocalName);
	} else
		ok=CopyFile(RemoteName+pluginrootlen,LocalName,!OverWrite);
	
	if (ok) {
		ProgressProc(PluginNumber,RemoteName,LocalName,100);
		return FS_FILE_OK;
	} else {
		err=GetLastError();
		switch (err) {
		case 2:
		case 3:
		case 4:
		case 5:
			return FS_FILE_NOTFOUND;
		case ERROR_FILE_EXISTS:
			return FS_FILE_EXISTS;
		default:
			return FS_FILE_READERROR;
		}
	}
}


int __stdcall FsPutFile(char* LocalName,char* RemoteName,int CopyFlags)
{
    int err;
	BOOL ok,OverWrite,Resume,Move;

	OverWrite=CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=CopyFlags & FS_COPYFLAGS_RESUME;
	Move=CopyFlags & FS_COPYFLAGS_MOVE;
	if (Resume)
		return FS_FILE_NOTSUPPORTED;

	if (strlen(RemoteName)<pluginrootlen+2 || strlen(RemoteName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;
	
	err=ProgressProc(PluginNumber,LocalName,RemoteName,0);
	if (err)
		return FS_FILE_USERABORT;
	if (Move) {
		if (OverWrite)
			DeleteFile(RemoteName+pluginrootlen);
		ok=MoveFile(LocalName,RemoteName+pluginrootlen);
	} else
		ok=CopyFile(LocalName,RemoteName+pluginrootlen,!OverWrite);

	if (ok) {
		ProgressProc(PluginNumber,RemoteName,LocalName,100);
		return FS_FILE_OK;
	} else {
		err=GetLastError();
		switch (err) {
		case 2:
		case 3:
		case 4:
		case 5:
			return FS_FILE_NOTFOUND;
		case ERROR_FILE_EXISTS:
			return FS_FILE_EXISTS;
		default:
			return FS_FILE_READERROR;
		}
	}
}

BOOL __stdcall FsDeleteFile(char* RemoteName)
{
	if (strlen(RemoteName)<pluginrootlen+2)
		return false;

	return DeleteFile(RemoteName+pluginrootlen);	
}

BOOL __stdcall FsRemoveDir(char* RemoteName)
{
	if (strlen(RemoteName)<pluginrootlen+2)
		return false;

	return RemoveDirectory(RemoteName+pluginrootlen);	
}

BOOL __stdcall FsSetAttr(char* RemoteName,int NewAttr)
{
	if (strlen(RemoteName)<pluginrootlen+2)
		return false;

	if (NewAttr==0)
		NewAttr=FILE_ATTRIBUTE_NORMAL;
	return SetFileAttributes(RemoteName+pluginrootlen,NewAttr);	
}

BOOL __stdcall FsSetTime(char* RemoteName,FILETIME *CreationTime,
      FILETIME *LastAccessTime,FILETIME *LastWriteTime)
{
	if (strlen(RemoteName)<pluginrootlen+2)
		return false;

	HANDLE filehandle = CreateFile (RemoteName+pluginrootlen,	
                      GENERIC_WRITE,          // Open for writing
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL);

	if (filehandle==INVALID_HANDLE_VALUE)
		return FALSE;

	BOOL retval=SetFileTime(filehandle,CreationTime,LastAccessTime,LastWriteTime);
    CloseHandle(filehandle);
	return retval;
}

void __stdcall FsStatusInfo(char* RemoteDir,int InfoStartEnd,int InfoOperation)
{
	// This function may be used to initialize variables and to flush buffers
	
/*	char text[MAX_PATH];

	if (InfoStartEnd==FS_STATUS_START)
		strcpy(text,"Start: ");
	else
		strcpy(text,"End: ");
	
	switch (InfoOperation) {
	case FS_STATUS_OP_LIST:
		strcat(text,"Get directory list");
		break;
	case FS_STATUS_OP_GET_SINGLE:
		strcat(text,"Get single file");
		break;
	case FS_STATUS_OP_GET_MULTI:
		strcat(text,"Get multiple files");
		break;
	case FS_STATUS_OP_PUT_SINGLE:
		strcat(text,"Put single file");
		break;
	case FS_STATUS_OP_PUT_MULTI:
		strcat(text,"Put multiple files");
		break;
	case FS_STATUS_OP_RENMOV_SINGLE:
		strcat(text,"Rename/Move/Remote copy single file");
		break;
	case FS_STATUS_OP_RENMOV_MULTI:
		strcat(text,"Rename/Move/Remote copy multiple files");
		break;
	case FS_STATUS_OP_DELETE:
		strcat(text,"Delete multiple files");
		break;
	case FS_STATUS_OP_ATTRIB:
		strcat(text,"Change attributes of multiple files");
		break;
	case FS_STATUS_OP_MKDIR:
		strcat(text,"Create directory");
		break;
	case FS_STATUS_OP_EXEC:
		strcat(text,"Execute file or command line");
		break;
	default:
		strcat(text,"Unknown operation");
	}
	if (InfoOperation != FS_STATUS_OP_LIST)   // avoid recursion due to re-reading!
		MessageBox(0,text,RemoteDir,0);
*/
}

void __stdcall FsGetDefRootName(char* DefRootName,int maxlen)
{
	strlcpy(DefRootName,"Drives",maxlen);
}
