/***********************************************************************
 mbox.c - A simple "message box" function, vaguely modelled on the
    Windows API MessageBox function.
    
 This routine is in the Public Domain.
***********************************************************************/

#include <PalmOS.h>

#include "mbox.h"

//// MessageBox ////////////////////////////////////////////////////////
// A vaguely Windows-like message box display function.

void MessageBox(const char* pc, MessageBoxType eType)
{
    switch (eType) {
        case MB_ICONINFORMATION:
            FrmCustomAlert(MessageBoxInfoAlert, pc, 0, 0);
            break;

        case MB_ICONEXCLAMATION:
            FrmCustomAlert(MessageBoxWarningAlert, pc, 0, 0);
            break;

        case MB_ICONSTOP:
            FrmCustomAlert(MessageBoxErrorAlert, pc, 0, 0);
            break;
    }
}

    

