// wincefs.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "fsplugin.h"

#define DefPluginTitle "WinCE Device"

tProgressProc ProgressProc;
tLogProc LogProc;
tRequestProc RequestProc;
int PluginNumber;

char* strlcpy(char* p,char*p2,int maxlen)
{
	if ((int)strlen(p2)>=maxlen) {
		strncpy(p,p2,maxlen);
		p[maxlen]=0;
	} else
		strcpy(p,p2);
	return p;
}

char* strlcat(char* p,char*p2,int maxlen)
{
	int restlen=maxlen-strlen(p);
	if (restlen>0)
		strlcpy(p+strlen(p),p2,restlen);
	return p;
}

LPTSTR strlcatbackslash(char* thedir,int maxlen)
{
	if (thedir[0] && strlen(thedir)<(DWORD)maxlen)
		if (thedir[strlen(thedir)-1]!='\\')
			strcat(thedir,"\\");
	return thedir;
}

BOOL ceinitialized=FALSE;

BOOL InitCeFunctionsIfNeeded(BOOL trueconnect)
{
	if(ceinitialized)
		return TRUE;
	RAPIINIT rpi;
	rpi.cbSize=sizeof(RAPIINIT);
	rpi.heRapiInit=NULL;
	rpi.hrRapiInit=0;
	if (SUCCEEDED(CeRapiInitEx(&rpi))) {
		if (WaitForSingleObject(rpi.heRapiInit,5000)!=WAIT_OBJECT_0) {
			CeRapiUninit();
			MessageBeep(MB_ICONSTOP);
			return FALSE;
		} else {
			if (!SUCCEEDED(rpi.hrRapiInit)) {
				CeRapiUninit();
				MessageBeep(MB_ICONSTOP);
				return FALSE;
			} else {
				ceinitialized=TRUE;
				char buf1[MAX_PATH];
				strcpy(buf1,"CONNECT \\");   //very important: Message MUST be
				if (trueconnect)             //CONNECT Full path!!!
					LogProc(PluginNumber,MSGTYPE_CONNECT,buf1);
				return TRUE;
			}
		}
	} else
		return FALSE;
}

void FreeCeFunctions()
{
	if (ceinitialized) {
		CeRapiUninit();
		ceinitialized=FALSE;
	}
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	if (ul_reason_for_call==DLL_PROCESS_DETACH)
		FreeCeFunctions();
    return TRUE;
}

int __stdcall FsInit(int PluginNr,tProgressProc pProgressProc,tLogProc pLogProc,tRequestProc pRequestProc)
{
	PluginNumber=PluginNr;
	ProgressProc=pProgressProc;
    LogProc=pLogProc;
    RequestProc=pRequestProc;
	return 0;
}

typedef struct {
	char Path[MAX_PATH];
	char LastFoundName[MAX_PATH];
    LPCE_FIND_DATA pFindDataArray;
	DWORD dwFoundCount;
	DWORD dwLastUsed;
} tLastFindStuct,*pLastFindStuct;

BOOL __stdcall FsDisconnect(char* DisconnectRoot)
{
	FreeCeFunctions();
	char buf1[MAX_PATH];
	strcpy(buf1,"DISCONNECT ");
	strlcat(buf1,DisconnectRoot,MAX_PATH-1);
	LogProc(PluginNumber,MSGTYPE_DISCONNECT,buf1);
	return TRUE;
}

HANDLE __stdcall FsFindFirst(char* Path,WIN32_FIND_DATA *FindData)
{
	char buf[MAX_PATH];
	pLastFindStuct lf;
	
	memset(FindData,0,sizeof(WIN32_FIND_DATA));
	if (Path[0]=='\\') {
		if (!InitCeFunctionsIfNeeded(TRUE)) {
			return INVALID_HANDLE_VALUE;
		}

		strcpy(buf,Path);           // incl. Backslash!
		strlcatbackslash(buf,sizeof(buf)-1);
		strlcat(buf,"*.*",sizeof(buf)-1);

		WCHAR wcSearch[MAX_PATH];
		LPCE_FIND_DATA pFindDataArray;

		MultiByteToWideChar(CP_ACP,0,buf,-1,wcSearch,MAX_PATH-1);

		BOOL found;
		DWORD dwFoundCount;

		for (int i=0;i<2;i++) {
			__try {
				found=CeFindAllFiles(wcSearch,FAF_ATTRIBUTES | FAF_LASTWRITE_TIME |
				  FAF_SIZE_HIGH | FAF_SIZE_LOW | FAF_NAME,
				  &dwFoundCount,&pFindDataArray);

			} 
			__except(TRUE) {
				found=false;
				break;
			}
			if (found)
				break;
			else if (i==0) {           // re-init just in case the connection was lost
				FreeCeFunctions();
				InitCeFunctionsIfNeeded(FALSE);
			}
		}
		if (found) {
			char buf1[MAX_PATH];
			strcpy(buf1,"GET DIR ");
			strlcat(buf1,buf,MAX_PATH-1);
			LogProc(PluginNumber,MSGTYPE_OPERATIONCOMPLETE,buf1);

			if (dwFoundCount==0) {
				CeRapiFreeBuffer(pFindDataArray);
				SetLastError(ERROR_NO_MORE_FILES);
				return INVALID_HANDLE_VALUE;
			}

			WideCharToMultiByte(CP_ACP,0,pFindDataArray[0].cFileName,-1,FindData->cFileName,MAX_PATH-2,NULL,NULL);
			FindData->dwFileAttributes=pFindDataArray[0].dwFileAttributes;
			FindData->ftLastWriteTime=pFindDataArray[0].ftLastWriteTime;
			FindData->nFileSizeHigh=pFindDataArray[0].nFileSizeHigh;
			FindData->nFileSizeLow=pFindDataArray[0].nFileSizeLow;

			lf=(pLastFindStuct)malloc(sizeof(tLastFindStuct));
			strcpy(lf->Path,buf);
			lf->pFindDataArray=pFindDataArray;
			lf->dwFoundCount=dwFoundCount;
			lf->dwLastUsed=0;
			return (HANDLE)lf;
		}
	}
	SetLastError(ERROR_PATH_NOT_FOUND);
	return INVALID_HANDLE_VALUE;
}

BOOL __stdcall FsFindNext(HANDLE Hdl,WIN32_FIND_DATA *FindData)
{
	pLastFindStuct lf;

	if ((int)Hdl==1)
		return false;

	lf=(pLastFindStuct)Hdl;
	if (lf->pFindDataArray) {
		lf->dwLastUsed++;
		if (lf->dwLastUsed<lf->dwFoundCount) {
			DWORD dw=lf->dwLastUsed;
			
			memset(FindData,0,sizeof(WIN32_FIND_DATA));
			WideCharToMultiByte(CP_ACP,0,lf->pFindDataArray[dw].cFileName,-1,FindData->cFileName,MAX_PATH-2,NULL,NULL);
			FindData->dwFileAttributes=lf->pFindDataArray[dw].dwFileAttributes; //| 0x80000000;
//			FindData->dwReserved0=0x7F;
			FindData->ftLastWriteTime=lf->pFindDataArray[dw].ftLastWriteTime;
			FindData->nFileSizeHigh=lf->pFindDataArray[dw].nFileSizeHigh;
			FindData->nFileSizeLow=lf->pFindDataArray[dw].nFileSizeLow;
			return true;
		}
	}
	return false;
}

int __stdcall FsFindClose(HANDLE Hdl)
{
	if ((int)Hdl==1)
		return 0;
	pLastFindStuct lf;
	lf=(pLastFindStuct)Hdl;
	if (lf->pFindDataArray) {
		CeRapiFreeBuffer(lf->pFindDataArray);
		lf->pFindDataArray=NULL;
	}
	free(lf);
	return 0;
}

BOOL __stdcall FsMkDir(char* Path)
{
	if (Path[0]!='\\')
		return false;

	InitCeFunctionsIfNeeded(TRUE);

	WCHAR wcSearch[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,Path,-1,wcSearch,MAX_PATH-1);
	return CeCreateDirectory(wcSearch,NULL);
}

int __stdcall FsExecuteFile(HWND MainWin,char* RemoteName,char* Verb)
{
	WCHAR wRemoteName[MAX_PATH],wbuf[MAX_PATH];

	if (RemoteName[0]!='\\')
		return FS_EXEC_ERROR;
	
	if (stricmp(Verb,"open")==0) {
		char* p=strrchr(RemoteName,'.');
		if (p && stricmp(p,".lnk")==0) { // A shortcut?
			InitCeFunctionsIfNeeded(TRUE);
			MultiByteToWideChar(CP_ACP,0,RemoteName,-1,wRemoteName,MAX_PATH-1);

			if (CeSHGetShortcutTarget(wRemoteName,wbuf,MAX_PATH-1)) {
				WCHAR* wp=wbuf;
				if (wp[0]=='"') {    // Remove double quotes
					wp++;
					WCHAR *wpend=wp+wcslen(wp)-1;
					if (wpend[0]=='"')
						wpend[0]=0;
				}
				DWORD attr=CeGetFileAttributes(wp);
				if (attr!=0xFFFFFFFF && (attr & FILE_ATTRIBUTE_DIRECTORY)) {
					WideCharToMultiByte(CP_ACP,0,wp,-1,RemoteName,MAX_PATH-1,NULL,NULL);
					return FS_EXEC_SYMLINK;
				} else
					return FS_EXEC_ERROR;  // can't execute linked docs
			}
		}
		return FS_EXEC_YOURSELF;
	} else if (stricmp(Verb,"properties")==0) {
		return FS_EXEC_YOURSELF;
	} else if (strnicmp(Verb,"quote ",6)==0) {
		MessageBox(MainWin,Verb,"Quote verb not supported!",MB_ICONEXCLAMATION);
		return FS_EXEC_ERROR;
	} else if (strnicmp(Verb,"chmod ",6)==0) {
		MessageBox(MainWin,RemoteName,"Chmod verb not supported!",MB_ICONEXCLAMATION);
		return FS_EXEC_ERROR;
	} else
		return FS_EXEC_ERROR;
}

int __stdcall FsRenMovFile(char* OldName,char* NewName,BOOL Move,BOOL OverWrite,RemoteInfoStruct* ri)
{
	if (OldName[0]!='\\'  || NewName[0]!='\\')
		return FS_FILE_NOTFOUND;

	int err=ProgressProc(PluginNumber,OldName,NewName,0);
	if (err)
		return FS_FILE_USERABORT;

	WCHAR wOldName[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,OldName,-1,wOldName,MAX_PATH-1);

	WCHAR wNewName[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,NewName,-1,wNewName,MAX_PATH-1);

	InitCeFunctionsIfNeeded(TRUE);

	char buf1[MAX_PATH];
	if (Move) 
		strcpy(buf1,"MOVE ");
	else
		strcpy(buf1,"COPY ");

	int retval=FS_FILE_NOTFOUND;

	if (Move) {
		if (OverWrite)
			CeDeleteFile(wNewName);
		if (CeMoveFile(wOldName,wNewName))
			retval=FS_FILE_OK;
	} else {
		if (CeCopyFile(wOldName,wNewName,!OverWrite))
			retval=FS_FILE_OK;
	}

	if (retval!=FS_FILE_OK) {
		switch(CeGetLastError()) {
			case ERROR_FILE_NOT_FOUND:
			case ERROR_PATH_NOT_FOUND:
			case ERROR_ACCESS_DENIED:
				return FS_FILE_NOTFOUND;
			case ERROR_FILE_EXISTS:
				return FS_FILE_EXISTS;
			default:
				return FS_FILE_WRITEERROR;
		}
	}
	err=ProgressProc(PluginNumber,OldName,NewName,100);
	if (err)
		return FS_FILE_USERABORT;
	else {
		strlcat(buf1,OldName,MAX_PATH-1);
		strlcat(buf1,"->",MAX_PATH-1);
		strlcat(buf1,NewName,MAX_PATH-1);
		LogProc(PluginNumber,MSGTYPE_OPERATIONCOMPLETE,buf1);
		return FS_FILE_OK;
	}
}

#define partblocksz 8192

typedef struct {
	char* LocalName;
	char* RemoteName;
	int CopyFlags;
	int Percent;
	RemoteInfoStruct* ri;
	bool Aborted;
} threaddata,*threaddataptr;


DWORD WINAPI DownloadThreadProc(LPVOID lpParameter)
{
	int err;
	BOOL OverWrite,Resume;
	threaddataptr tdp=(threaddataptr)lpParameter;

	OverWrite=tdp->CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=tdp->CopyFlags & FS_COPYFLAGS_RESUME;

	WCHAR wfullname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,tdp->RemoteName,-1,wfullname,MAX_PATH-1);

	// Open remote file
	HANDLE remotefilehandle = CeCreateFile (wfullname,	
                      GENERIC_READ,           // Open for reading
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL);

	if (remotefilehandle==INVALID_HANDLE_VALUE)
		return FS_FILE_NOTFOUND;

	HANDLE localfilehandle;
	if (Resume) {
		// Open local file
		localfilehandle = CreateFile(tdp->LocalName,GENERIC_WRITE,0,NULL,
			OPEN_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,NULL);
		if (localfilehandle==INVALID_HANDLE_VALUE) {
			err=GetLastError();
			CeCloseHandle(remotefilehandle);
			if (err=ERROR_FILE_EXISTS)
				return FS_FILE_EXISTS;
			else
				return FS_FILE_WRITEERROR;
		}
	} else {
		// Create local file
		localfilehandle = CreateFile(tdp->LocalName,GENERIC_WRITE,0,NULL,
			OverWrite ? CREATE_ALWAYS : CREATE_NEW,
			FILE_ATTRIBUTE_NORMAL,NULL);
		if (localfilehandle==INVALID_HANDLE_VALUE) {
			err=GetLastError();
			CeCloseHandle(remotefilehandle);
			if (err=ERROR_FILE_EXISTS)
				return FS_FILE_EXISTSRESUMEALLOWED;
			else
				return FS_FILE_WRITEERROR;
		}
	}

	INT64 totalsize=tdp->ri->SizeHigh;
	totalsize=totalsize << 32 | tdp->ri->SizeLow;
	INT64 totalcopied=0;

	if (Resume) {
		DWORD seeklow;
		LONG seekhigh=0;
		seeklow=SetFilePointer(localfilehandle,0,&seekhigh,FILE_END);
		totalcopied=seekhigh;
		totalcopied=totalcopied << 32 | seeklow;
		seeklow=CeSetFilePointer(remotefilehandle,seeklow,&seekhigh,FILE_BEGIN);
		if (seeklow=0xFFFFFFFF && CeGetLastError()!=NO_ERROR) {
			// seek failed!
			CeCloseHandle(remotefilehandle);
			CloseHandle(localfilehandle);
			return FS_FILE_READERROR;
		}
	}

	DWORD cbread,cbwritten,readblocksz;
	char block[partblocksz];
	int starttime;
	readblocksz=partblocksz;

	err=0;
	do {
//		starttime=GetCurrentTime();
		if (!CeReadFile(remotefilehandle,&block,readblocksz,&cbread,NULL)) {
			err=FS_FILE_READERROR;
			break;
		} 
/*		starttime=GetCurrentTime()-starttime;
		while (readblocksz>2048 && starttime>1000) {  // dynamic block size
			readblocksz/=2;
			starttime/=2;
		}
*/		if (!WriteFile(localfilehandle,&block,cbread,&cbwritten,NULL) || cbread!=cbwritten) {
			err=FS_FILE_WRITEERROR;
			break;
		} else {   // read+write succeeded!
			totalcopied+=cbread;
			if (totalsize)         // may be zero if file was erroneously reported as 0 bytes
				tdp->Percent=(int)min(100,totalcopied*100.0/totalsize);
			else
				tdp->Percent=0;
			if (tdp->Aborted) {
				CeCloseHandle(remotefilehandle);
				CloseHandle(localfilehandle);
				return FS_FILE_USERABORT;
			}
		}
	} while (cbread>=readblocksz);
	if (tdp->ri->LastWriteTime.dwHighDateTime || tdp->ri->LastWriteTime.dwLowDateTime)
		SetFileTime(localfilehandle,NULL,NULL,&tdp->ri->LastWriteTime);
	CeCloseHandle(remotefilehandle);
	CloseHandle(localfilehandle);
	return err;
}


int __stdcall FsGetFile(char* RemoteName,char* LocalName,int CopyFlags,RemoteInfoStruct* ri)
{
    int err;
	BOOL OverWrite,Resume,Move;

	OverWrite=CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=CopyFlags & FS_COPYFLAGS_RESUME;
	Move=CopyFlags & FS_COPYFLAGS_MOVE;

	if (RemoteName[0]!='\\')
		return FS_FILE_NOTFOUND;

	err=ProgressProc(PluginNumber,RemoteName,LocalName,0);
	if (err)
		return FS_FILE_USERABORT;

	if (!InitCeFunctionsIfNeeded(TRUE))
		return FS_FILE_READERROR;

	threaddata td;

	td.CopyFlags=CopyFlags;
	td.LocalName=LocalName;
	td.RemoteName=RemoteName;
	td.Percent=0;
	td.ri=ri;
	td.Aborted=false;
	HANDLE hThread;
	DWORD pThreadId;

	hThread=CreateThread(NULL, 
				0,
				(LPTHREAD_START_ROUTINE)&DownloadThreadProc,
				&td,
				0,
                &pThreadId);

	if (!hThread)
		return FS_FILE_READERROR;

	int oldpercent=0;
	err=WaitForSingleObject(hThread,500);
	
	while (err==WAIT_TIMEOUT) {
//		if (oldpercent!=td.Percent)
		{
			oldpercent=td.Percent;
			if (ProgressProc(PluginNumber,LocalName,RemoteName,oldpercent)) {
				td.Aborted=true;
			}
		}
		err=WaitForSingleObject(hThread,500);
	} 

	DWORD dwcode;
	if (!GetExitCodeThread(hThread,&dwcode))
		return FS_FILE_READERROR;

	CloseHandle(hThread);
	err=(int)dwcode;


	char buf1[MAX_PATH];
	strcpy(buf1,"GET ");
	strlcat(buf1,RemoteName,MAX_PATH-1);
	strlcat(buf1,"->",MAX_PATH-1);
	strlcat(buf1,LocalName,MAX_PATH-1);
	LogProc(PluginNumber,MSGTYPE_OPERATIONCOMPLETE,buf1);

	if (!err) {
		ProgressProc(PluginNumber,RemoteName,LocalName,100);

		if (Move) {
			WCHAR wfullname[MAX_PATH];
			MultiByteToWideChar(CP_ACP,0,RemoteName,-1,wfullname,MAX_PATH-1);
			
			if (!CeDeleteFile(wfullname))       // New! Plugin deletes on Move
				return FS_FILE_WRITEERROR;
		}

		return FS_FILE_OK;
	} else {
		return err;
	}
}

DWORD WINAPI UploadThreadProc(LPVOID lpParameter)
{
	int err;
	BOOL OverWrite,Resume;
	threaddataptr tdp=(threaddataptr)lpParameter;

	OverWrite=tdp->CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=tdp->CopyFlags & FS_COPYFLAGS_RESUME;

	WCHAR wfullname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,tdp->RemoteName,-1,wfullname,MAX_PATH-1);

	// Open local file
	HANDLE localfilehandle = CreateFile (tdp->LocalName,	
                      GENERIC_READ,           // Open for reading
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL);

	if (localfilehandle==INVALID_HANDLE_VALUE)
		return FS_FILE_NOTFOUND;
	
	HANDLE remotefilehandle;

	if (Resume) {
		// Open remote file
		remotefilehandle = CeCreateFile(wfullname,GENERIC_WRITE,0,NULL,
			OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

		if (remotefilehandle==INVALID_HANDLE_VALUE) {
			CloseHandle(localfilehandle);
			return FS_FILE_WRITEERROR;
		}
	} else {
		// Create remote file
		remotefilehandle = CeCreateFile(wfullname,GENERIC_WRITE,0,NULL,
			OverWrite ? CREATE_ALWAYS : CREATE_NEW,
			FILE_ATTRIBUTE_NORMAL,NULL);

		if (remotefilehandle==INVALID_HANDLE_VALUE) {
			err=CeGetLastError();
			CloseHandle(localfilehandle);
			if (err==ERROR_FILE_EXISTS)
				return  FS_FILE_EXISTSRESUMEALLOWED;
			else
				return FS_FILE_WRITEERROR;
		}
	}

	DWORD totalsizehigh=0;
	DWORD totalsizelow=GetFileSize(localfilehandle,&totalsizehigh);
	INT64 totalsize=totalsizehigh;
	totalsize=totalsize << 32 | totalsizelow;
	INT64 totalcopied=0;

	if (Resume) {
		DWORD seeklow;
		LONG seekhigh=0;
		seeklow=CeSetFilePointer(remotefilehandle,0,&seekhigh,FILE_END);
		totalcopied=seekhigh;
		totalcopied=totalcopied << 32 | seeklow;
		seeklow=SetFilePointer(localfilehandle,seeklow,&seekhigh,FILE_BEGIN);
		if (seeklow=0xFFFFFFFF && GetLastError()!=NO_ERROR) {
			// seek failed!
			CeCloseHandle(remotefilehandle);
			CloseHandle(localfilehandle);
			return FS_FILE_READERROR;
		}
	}

	DWORD cbread,cbwritten,readblocksz;
	char block[partblocksz];
//	int starttime;
	readblocksz=partblocksz;

	err=0;
	do {
//		starttime=GetCurrentTime();
		if (!ReadFile(localfilehandle,&block,readblocksz,&cbread,NULL)) {
			err=FS_FILE_READERROR;
			break;

		} else if (!CeWriteFile(remotefilehandle,&block,cbread,&cbwritten,NULL) || cbread!=cbwritten) {
			err=FS_FILE_WRITEERROR;
			break;
		} else {   // read+write succeeded!
/*			starttime=GetCurrentTime()-starttime;
			while (readblocksz>4096 && starttime>1000) {  // dynamic block size
				readblocksz/=2;
				starttime/=2;
			}
*/
			totalcopied+=cbread;
			if (totalsize)         // may be zero if file was erroneously reported as 0 bytes
				tdp->Percent=(int)min(100,totalcopied*100.0/totalsize);
			else
				tdp->Percent=0;
			if (tdp->Aborted) {
				CeCloseHandle(remotefilehandle);
				CloseHandle(localfilehandle);
				return FS_FILE_USERABORT;
			}
		}
	} while (cbread>=readblocksz);
	FILETIME LastWriteTime;
	if (GetFileTime(localfilehandle,NULL,NULL,&LastWriteTime))
		CeSetFileTime(remotefilehandle,NULL,NULL,&LastWriteTime);
	CeCloseHandle(remotefilehandle);
	CloseHandle(localfilehandle);
	return err;
}

int __stdcall FsPutFile(char* LocalName,char* RemoteName,int CopyFlags)
{
	int err;
	BOOL OverWrite,Resume,Move;

	OverWrite=CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=CopyFlags & FS_COPYFLAGS_RESUME;
	Move=CopyFlags & FS_COPYFLAGS_MOVE;
	
	if (RemoteName[0]!='\\')
		return FS_FILE_NOTFOUND;

	err=ProgressProc(PluginNumber,LocalName,RemoteName,0);
	if (err)
		return FS_FILE_USERABORT;
	
	if (!InitCeFunctionsIfNeeded(TRUE))
		return FS_FILE_READERROR;

	threaddata td;

	td.CopyFlags=CopyFlags;
	td.LocalName=LocalName;
	td.RemoteName=RemoteName;
	td.Percent=0;
	td.Aborted=false;
	HANDLE hThread;
	DWORD pThreadId;

	hThread=CreateThread(NULL, 
				0,
				(LPTHREAD_START_ROUTINE)&UploadThreadProc,
				&td,
				0,
                &pThreadId);

	if (!hThread)
		return FS_FILE_READERROR;

	int oldpercent=0;
	err=WaitForSingleObject(hThread,500);
	
	while (err==WAIT_TIMEOUT) {
		if (oldpercent!=td.Percent) {
			oldpercent=td.Percent;
			if (ProgressProc(PluginNumber,LocalName,RemoteName,oldpercent)) {
				td.Aborted=true;
			}
		}
		err=WaitForSingleObject(hThread,500);
	} 

	DWORD dwcode;
	if (!GetExitCodeThread(hThread,&dwcode))
		return FS_FILE_READERROR;

	CloseHandle(hThread);
	err=(int)dwcode;

	char buf1[MAX_PATH];
	strcpy(buf1,"PUT ");
	if (err)
		strcat(buf1,"ERROR ");
	strlcat(buf1,LocalName,MAX_PATH-1);
	strlcat(buf1,"->",MAX_PATH-1);
	strlcat(buf1,RemoteName,MAX_PATH-1);
	LogProc(PluginNumber,MSGTYPE_OPERATIONCOMPLETE,buf1);

	if (err==0) {
		ProgressProc(PluginNumber,LocalName,RemoteName,100);
		if (Move)
			if (!DeleteFile(LocalName))
				return FS_FILE_WRITEERROR;
		return FS_FILE_OK;
	} else {
		return err;
	}
}

BOOL __stdcall FsDeleteFile(char* RemoteName)
{
	if (RemoteName[0]!='\\')
		return false;

	InitCeFunctionsIfNeeded(TRUE);

	WCHAR wcSearch[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,RemoteName,-1,wcSearch,MAX_PATH-1);
	return CeDeleteFile(wcSearch);	
}

BOOL __stdcall FsRemoveDir(char* RemoteName)
{
	if (RemoteName[0]!='\\')
		return false;

	InitCeFunctionsIfNeeded(TRUE);

	WCHAR wcSearch[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,RemoteName,-1,wcSearch,MAX_PATH-1);
	return CeRemoveDirectory(wcSearch);	
}

BOOL __stdcall FsSetAttr(char* RemoteName,int NewAttr)
{
	if (RemoteName[0]!='\\')
		return false;

	InitCeFunctionsIfNeeded(TRUE);

	WCHAR wcSearch[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,RemoteName,-1,wcSearch,MAX_PATH-1);
	if (NewAttr==0)
		NewAttr=FILE_ATTRIBUTE_NORMAL;
	return CeSetFileAttributes(wcSearch,NewAttr);	
}

BOOL __stdcall FsSetTime(char* RemoteName,FILETIME *CreationTime,
      FILETIME *LastAccessTime,FILETIME *LastWriteTime)
{
	if (RemoteName[0]!='\\')
		return false;

	InitCeFunctionsIfNeeded(TRUE);

	WCHAR wcSearch[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,RemoteName,-1,wcSearch,MAX_PATH-1);

	HANDLE remotefilehandle = CeCreateFile (wcSearch,	
                      GENERIC_WRITE,          // Open for writing
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL);

	if (remotefilehandle==INVALID_HANDLE_VALUE)
		return FALSE;

	BOOL retval=CeSetFileTime(remotefilehandle,CreationTime,LastAccessTime,LastWriteTime);
    CeCloseHandle(remotefilehandle);
	return retval;
}

void __stdcall FsGetDefRootName(char* DefRootName,int maxlen)
{
	strlcpy(DefRootName,DefPluginTitle,maxlen-1);
}
